package cz.muni.fi.pb162.test2;

import junit.framework.TestCase;

/**
 *
 * @author petr
 */
public class MotorGeneratorTest extends TestCase {
    
    public MotorGeneratorTest(String testName) {
        super(testName);
    }
    
    public void testMotorGetEfficiency() {
        ElectricDevice motor = new ElectricMotor(0.5);
        assertEquals(0.5,motor.getEfficiency(),0.000001);
        motor = new ElectricMotor(0.25);
        assertEquals(0.25,motor.getEfficiency(),0.000001);
    }

    public void testMotorToString() {
        ElectricDevice motor = new ElectricMotor(0.5);
        assertEquals("[Elektrick\u00fd motor, \u00fa\u010dinnost = 0.5]",motor.toString());
        motor = new ElectricMotor(0.25);
        assertEquals("[Elektrick\u00fd motor, \u00fa\u010dinnost = 0.25]",motor.toString());
    }

    public void testGeneratorGetEfficiency() {
        ElectricDevice generator = new ElectricGenerator(0.5);
        assertEquals(0.5,generator.getEfficiency(),0.000001);
        generator = new ElectricGenerator(0.25);
        assertEquals(0.25,generator.getEfficiency(),0.000001);
    }

    public void testGeneratorToString() {
        ElectricDevice generator = new ElectricGenerator(0.5);
        assertEquals("[Elektrick\u00fd gener\u00e1tor, \u00fa\u010dinnost = 0.5]",generator.toString());
        generator = new ElectricGenerator(0.25);
        assertEquals("[Elektrick\u00fd gener\u00e1tor, \u00fa\u010dinnost = 0.25]",generator.toString());
    }
    
    public void testGetMotorGeneratorEfficiency() {
        ElectricGenerator generator = new ElectricGenerator(0.5);
        ElectricMotor motor = new ElectricMotor(0.25);
        ElectricDevice motorgenerator = new MotorGenerator(motor,generator);
        assertEquals(0.125,motorgenerator.getEfficiency(),0.000001);

        generator = new ElectricGenerator(0.25);
        motor = new ElectricMotor(0.125);
        motorgenerator = new MotorGenerator(motor,generator);
        assertEquals(0.03125,motorgenerator.getEfficiency(),0.000001);
    }

    public void testMotorGeneratorToString() {
        ElectricGenerator generator = new ElectricGenerator(0.5);
        ElectricMotor motor = new ElectricMotor(0.25);
        ElectricDevice motorgenerator = new MotorGenerator(motor,generator);
        assertEquals("[Motorgener\u00e1tor, \u00fa\u010dinnost = 0.125]",motorgenerator.toString());
        generator = new ElectricGenerator(0.25);
        motor = new ElectricMotor(0.125);
        motorgenerator = new MotorGenerator(motor,generator);
        assertEquals("[Motorgener\u00e1tor, \u00fa\u010dinnost = 0.03125]",motorgenerator.toString());
    }

    public void testClassHierarchy() {
        assertEquals(AbstractElectricDevice.class,ElectricGenerator.class.getSuperclass());
        assertEquals(AbstractElectricDevice.class,ElectricMotor.class.getSuperclass());
        assertFalse(AbstractElectricDevice.class.isAssignableFrom(MotorGenerator.class));
        assertFalse(MotorGenerator.class.isAssignableFrom(AbstractElectricDevice.class));
        assertFalse(ElectricMotor.class.isAssignableFrom(ElectricGenerator.class));
        assertFalse(ElectricGenerator.class.isAssignableFrom(ElectricMotor.class));
        assertTrue(ElectricDevice.class.isAssignableFrom(AbstractElectricDevice.class));
        assertTrue(ElectricDevice.class.isAssignableFrom(ElectricMotor.class));
        assertTrue(ElectricDevice.class.isAssignableFrom(ElectricGenerator.class));
        assertTrue(ElectricDevice.class.isAssignableFrom(MotorGenerator.class));
    }
    
}
